; ***********************************************************************************
; * Toggle Output																	*
; ***********************************************************************************
ToggleOutput0:
	ldi		XL,K_Relais1
	eor		R_OUTPUT,XL
	ret

ToggleOutput1:
	ldi		XL,K_Relais2
	eor		R_OUTPUT,XL
	ret

ToggleOutput2:
	ldi		XL,K_Relais3
	eor		R_OUTPUT,XL
	ret

ToggleOutput3:
	ldi		XL,K_Relais4
	eor		R_OUTPUT,XL
	ret

ToggleOutput4:
	ldi		XL,K_Relais5
	eor		R_OUTPUT,XL
	ret

ToggleOutput5:
	ldi		XL,K_Relais6
	eor		R_OUTPUT,XL
	ret

ToggleOutput6:
	ldi		XL,K_Relais7
	eor		R_OUTPUT,XL
	ret

; ***********************************************************************************
; * Set Output																		*
; ***********************************************************************************
SetOutput:
	sbrc	R_STATUS,Flag_AkkuLock
	clr		R_OUTPUT

	sbrc	R_STATUS,Flag_TempWarning
	andi	R_OUTPUT,0b10011111

SetOutput_End:
	out		OutputPort,R_OUTPUT
	ret

; ***********************************************************************************
; * Lfter Toggeln																	*
; ***********************************************************************************
ToggleLuefter:
	sbic	LuefterPort,Luefter
	rjmp	ToggleLuefter_IsHigh
	sbi		LuefterPort,Luefter
	rjmp	ToggleLuefter_End

ToggleLuefter_IsHigh:
	cbi		LuefterPort,Luefter

ToggleLuefter_End:
	ret

; ***********************************************************************************
; * Status LED Red Toggle															*
; ***********************************************************************************
ToggleStatusLEDRed:
	sbic	StatusLEDRedPort,StatusLEDRed
	rjmp	ToggleStatusLEDRed_IsHigh
	sbi		StatusLEDRedPort,StatusLEDRed
	rjmp	ToggleStatusLEDRed_End

ToggleStatusLEDRed_IsHigh:
	cbi		StatusLEDRedPort,StatusLEDRed

ToggleStatusLEDRed_End:
	ret

; ***********************************************************************************
; * Status LED Yellow Toggle														*
; ***********************************************************************************
ToggleStatusLEDYellow:
	sbic	StatusLEDYellowPort,StatusLEDYellow
	rjmp	ToggleStatusLEDYellow_IsHigh
	sbi		StatusLEDYellowPort,StatusLEDYellow
	rjmp	ToggleStatusLEDYellow_End

ToggleStatusLEDYellow_IsHigh:
	cbi		StatusLEDYellowPort,StatusLEDYellow

ToggleStatusLEDYellow_End:
	ret

; ***********************************************************************************
; * Relais 1 Toggle																	*
; ***********************************************************************************
ToggleRelais1:
	sbic	Relais1Port,Relais1
	rjmp	ToggleRelais1_IsHigh
	sbi		Relais1Port,Relais1
	rjmp	ToggleRelais1_End

ToggleRelais1_IsHigh:
	cbi		Relais1Port,Relais1

ToggleRelais1_End:
	ret

; ***********************************************************************************
; * Relais 2 Toggle																	*
; ***********************************************************************************
ToggleRelais2:
	sbic	Relais2Port,Relais2
	rjmp	ToggleRelais2_IsHigh
	sbi		Relais2Port,Relais2
	rjmp	ToggleRelais2_End

ToggleRelais2_IsHigh:
	cbi		Relais2Port,Relais2

ToggleRelais2_End:
	ret

; ***********************************************************************************
; * Relais 3 Toggle																	*
; ***********************************************************************************
ToggleRelais3:
	sbic	Relais3Port,Relais3
	rjmp	ToggleRelais3_IsHigh
	sbi		Relais3Port,Relais3
	rjmp	ToggleRelais3_End

ToggleRelais3_IsHigh:
	cbi		Relais3Port,Relais3

ToggleRelais3_End:
	ret

; ***********************************************************************************
; * Relais 4 Toggle																	*
; ***********************************************************************************
ToggleRelais4:
	sbic	Relais4Port,Relais4
	rjmp	ToggleRelais4_IsHigh
	sbi		Relais4Port,Relais4
	rjmp	ToggleRelais4_End

ToggleRelais4_IsHigh:
	cbi		Relais4Port,Relais4

ToggleRelais4_End:
	ret

; ***********************************************************************************
; * Relais 5 Toggle																	*
; ***********************************************************************************
ToggleRelais5:
	sbic	Relais5Port,Relais5
	rjmp	ToggleRelais5_IsHigh
	sbi		Relais5Port,Relais5
	rjmp	ToggleRelais5_End

ToggleRelais5_IsHigh:
	cbi		Relais5Port,Relais5

ToggleRelais5_End:
	ret

; ***********************************************************************************
; * Relais 6 Toggle																	*
; ***********************************************************************************
ToggleRelais6:
	sbic	Relais6Port,Relais6
	rjmp	ToggleRelais6_IsHigh
	sbi		Relais6Port,Relais6
	rjmp	ToggleRelais6_End

ToggleRelais6_IsHigh:
	cbi		Relais6Port,Relais6

ToggleRelais6_End:
	ret

; ***********************************************************************************
; * Relais 7 Toggle																	*
; ***********************************************************************************
ToggleRelais7:
	sbic	Relais7Port,Relais7
	rjmp	ToggleRelais7_IsHigh
	sbi		Relais7Port,Relais7
	rjmp	ToggleRelais7_End

ToggleRelais7_IsHigh:
	cbi		Relais7Port,Relais7

ToggleRelais7_End:
	ret

;************************************************************************************
;* Name: 	Read_Analog                                                            	*
;* input:	XL                                                                  	*
;* output:	XL                                                                  	*
;* Description:                                                                    	*
;* Read the analog value and store it to XL		                                    *
;***********************************************************************************+
Read_Analog:
	push	XH
	ori		XL,0b01100000										; right adjust
	out		ADMUX,XL	      									; Wahl Analog Channel
;	ldi		TempA,0b00010000	    							; adlar = 1
;	out		ADCSRB,TempA
	ldi		XL,0b11000100										; enable AD ;start conversion, clk/16
	out		ADCSRA,XL

Read_Analog_Wait:
	sbic    ADCSRA,ADSC											; wait until flag is clear
	rjmp	Read_Analog_Wait
	in		XH,ADCL												; nur dummy
	in		XH,ADCH												; store to location
	ldi		XL,0b11000100										; enable AD ;start conversion, clk/16
	out		ADCSRA,XL

Read_Analog_Wait1:
	sbic    ADCSRA,ADSC											; wait until flag is clear
	rjmp	Read_Analog_Wait1
	in		XL,ADCL												; nur dummy
	in		XL,ADCH												; store to location
	add		XL,XH												; add 1th and 2nd value
	ror		XL													; /2
	cbi		ADCSRA,ADEN											; disable Konverter
	pop		XH
	ret

; ***********************************************************************************
; * Name: 			EEPROM_Read														*
; * input:			YL,YH (Zeiger)													*
; * output:			XL																*
; * Description:    bernimmt mit YL, YH die EEPROM-Adresse und  					*
; *  				liest den entspr. Wert in XL aus  								*
; ***********************************************************************************
EEPROM_Read:
;	cbi		StatusLEDYellowPort,StatusLEDYellow
	sbic 	EECR,EEWE											; Wait for completion of previous write
	rjmp 	EEPROM_Read
	out 	EEARH,YH											; Set up address (YL:YH) in address register
	out 	EEARL,YL
	sbi 	EECR,EERE											; Start eeprom read by writing EERE
	in 		XL,EEDR												; Read data from data register
;	sbi		StatusLEDYellowPort,StatusLEDYellow
	ret

; ***********************************************************************************
; * Name: 			EEPROM_Write und _Wait											*
; * input:			YL,YH (Zeiger), XL (Wert)										*
; * output:																			*
; * Description:	bernimmt mit YL, YH die EEPROM-Adresse und						*
; *  				speichert den entspr. Wert aus XL 								*
; ***********************************************************************************
EEPROM_Write:
;	cbi		StatusLEDRedPort,StatusLEDRed	
	sbic 	EECR,EEWE											; Wait for completion of previous write
	rjmp 	EEPROM_Write
	out 	EEARH,YH											; Set up address (YL:YH) in address register
	out 	EEARL,YL
	out 	EEDR,XL												; Write data (XL) to data register
	sbi 	EECR,EEMWE											; Write logical one to EEMWE
	sbi 	EECR,EEWE											; Start eeprom write by setting EEWE
;	sbi		StatusLEDRedPort,StatusLEDRed		
	ret
